#ifndef __AtomicPropositions_h__
#define __AtomicPropositions_h__

#include "String.h"
#include "UniqueVector.h"

class AtomicPropositions
{
public:
    void add( const String &proposition )
    {
        _propositions.append( proposition );
    }

    String at( unsigned index )
    {
        return _propositions[index];
    }

    Vector<String> get() const
    {
        return _propositions;
    }

    unsigned size() const
    {
        return _propositions.size();
    }

private:
    UniqueVector<String> _propositions;
};

#endif // __AtomicPropositions_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
